# Class MultipartStream

java.lang.Object
org.apache.tomcat.util.http.fileupload.MultipartStream

public class MultipartStream extends Object
Low level API for processing file uploads.

This class can be used to process data streams conforming to MIME 'multipart' format as defined in RFC 1867. Arbitrarily large amounts of data in the stream can be processed under constant memory usage.

The format of the stream is defined in the following way:
`multipart-body := preamble 1*encapsulation close-delimiter epilogue
encapsulation := delimiter body CRLF
delimiter := "--" boundary CRLF
close-delimiter := "--" boundary "--"
preamble := <ignore>
epilogue := <ignore>
body := header-part CRLF body-part
header-part := 1*header CRLF
header := header-name ":" header-value
header-name := <printable ascii characters except ":">
header-value := <any ascii characters except CR & LF>
body-data := <arbitrary data>
`

Note that body-data can contain another mulipart entity. There is limited support for single pass processing of such nested streams. The nested stream is required to have a boundary token of the same length as the parent stream (see `setBoundary(byte[])`).

Here is an example of usage of this class.

       try {
         MultipartStream multipartStream = new MultipartStream(input, boundary);
         boolean nextPart = multipartStream.skipPreamble();
         OutputStream output;
         while(nextPart) {
           String header = multipartStream.readHeaders();
           // process headers
           // create some output stream
           multipartStream.readBodyData(output);
           nextPart = multipartStream.readBoundary();
         }
       } catch(MultipartStream.MalformedStreamException e) {
         // the stream failed to follow required syntax
       } catch(IOException e) {
         // a read or write error occurred
       }

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`MultipartStream.IllegalBoundaryException`
Thrown upon attempt of setting an invalid boundary token.
`class`
`MultipartStream.ItemInputStream`
An `InputStream` for reading an items contents.
`static class`
`MultipartStream.MalformedStreamException`
Thrown to indicate that the input stream fails to follow the required syntax.
`static class`
`MultipartStream.ProgressNotifier`
Internal class, which is used to invoke the `ProgressListener`.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected static final byte[]`
`BOUNDARY_PREFIX`
A byte sequence that precedes a boundary (`CRLF--`).
`static final byte`
`CR`
The Carriage Return ASCII character value.
`static final byte`
`DASH`
The dash (-) ASCII character value.
`protected static final int`
`DEFAULT_BUFSIZE`
The default length of the buffer used for processing a request.
`protected static final byte[]`
`FIELD_SEPARATOR`
A byte sequence that follows a delimiter that will be followed by an encapsulation (`CRLF`).
`protected static final byte[]`
`HEADER_SEPARATOR`
A byte sequence that marks the end of `header-part` (`CRLFCRLF`).
`static final byte`
`LF`
The Line Feed ASCII character value.
`protected static final byte[]`
`STREAM_TERMINATOR`
A byte sequence that follows a delimiter of the last encapsulation in the stream (`--`).

## Constructor Summary

Constructors
Constructor
Description
`MultipartStream(InputStream input, byte[] boundary, int bufSize, MultipartStream.ProgressNotifier notifier)`
Constructs a `MultipartStream` with a custom size buffer.
`MultipartStream(InputStream input, byte[] boundary, MultipartStream.ProgressNotifier notifier)`
Constructs a `MultipartStream` with a default size buffer.

## Method Summary

Modifier and Type
Method
Description
`static boolean`
`arrayequals(byte[] a, byte[] b, int count)`
Compares `count` first bytes in the arrays `a` and `b`.
`int`
`discardBodyData()`
Reads `body-data` from the current `encapsulation` and discards it.
`protected int`
`findSeparator()`
Searches for the `boundary` in the `buffer` region delimited by `head` and `tail`.
`String`
`getHeaderEncoding()`
Gets the character encoding used when reading the headers of an individual part.
`int`
`getPartHeaderSizeMax()`
Obtain the per part size limit for headers.
`MultipartStream.ItemInputStream`
`newInputStream()`
Creates a new `MultipartStream.ItemInputStream`.
`int`
`readBodyData(OutputStream output)`
Reads `body-data` from the current `encapsulation` and writes its contents into the output `Stream`.
`boolean`
`readBoundary()`
Skips a `boundary` token, and checks whether more `encapsulations` are contained in the stream.
`byte`
`readByte()`
Reads a byte from the `buffer`, and refills it as necessary.
`String`
`readHeaders()`
Reads the `header-part` of the current `encapsulation`.
`void`
`setBoundary(byte[] boundary)`
Changes the boundary token used for partitioning the stream.
`void`
`setHeaderEncoding(String encoding)`
Specifies the character encoding to be used when reading the headers of individual parts.
`void`
`setPartHeaderSizeMax(int partHeaderSizeMax)`
Sets the per part size limit for headers.
`boolean`
`skipPreamble()`
Finds the beginning of the first `encapsulation`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### CR

public static final byte CR
The Carriage Return ASCII character value.

See Also:
  - Constant Field Values

### LF

public static final byte LF
The Line Feed ASCII character value.

See Also:
  - Constant Field Values

### DASH

public static final byte DASH
The dash (-) ASCII character value.

See Also:
  - Constant Field Values

### DEFAULT_BUFSIZE

protected static final int DEFAULT_BUFSIZE
The default length of the buffer used for processing a request.

See Also:
  - Constant Field Values

### HEADER_SEPARATOR

protected static final byte[] HEADER_SEPARATOR
A byte sequence that marks the end of `header-part` (`CRLFCRLF`).

### FIELD_SEPARATOR

protected static final byte[] FIELD_SEPARATOR
A byte sequence that follows a delimiter that will be followed by an encapsulation (`CRLF`).

### STREAM_TERMINATOR

protected static final byte[] STREAM_TERMINATOR
A byte sequence that follows a delimiter of the last encapsulation in the stream (`--`).

### BOUNDARY_PREFIX

protected static final byte[] BOUNDARY_PREFIX
A byte sequence that precedes a boundary (`CRLF--`).

## Constructor Details

### MultipartStream

public MultipartStream(InputStream input, byte[] boundary, int bufSize, MultipartStream.ProgressNotifier notifier)
Constructs a `MultipartStream` with a custom size buffer.

Note that the buffer must be at least big enough to contain the boundary string, plus 4 characters for CR/LF and double dash, plus at least one byte of data. Too small a buffer size setting will degrade performance.

Parameters:
  `input` - The `InputStream` to serve as a data source.
  `boundary` - The token used for dividing the stream into `encapsulations`.
  `bufSize` - The size of the buffer to be used, in bytes.
  `notifier` - The notifier, which is used for calling the progress listener, if any.
Throws:
  `IllegalArgumentException` - If the buffer size is too small
Since:
  FileUpload 1.3.1

### MultipartStream

public MultipartStream(InputStream input, byte[] boundary, MultipartStream.ProgressNotifier notifier)
Constructs a `MultipartStream` with a default size buffer.

Parameters:
  `input` - The `InputStream` to serve as a data source.
  `boundary` - The token used for dividing the stream into `encapsulations`.
  `notifier` - An object for calling the progress listener, if any.
See Also:
  - `MultipartStream(InputStream, byte[], int, ProgressNotifier)`

## Method Details

### arrayequals

public static boolean arrayequals(byte[] a, byte[] b, int count)
Compares `count` first bytes in the arrays `a` and `b`.

Parameters:
  `a` - The first array to compare.
  `b` - The second array to compare.
  `count` - How many bytes should be compared.
Returns:
  `true` if `count` first bytes in arrays `a` and `b` are equal.

### discardBodyData

public int discardBodyData() throws MultipartStream.MalformedStreamException, IOException
Reads `body-data` from the current `encapsulation` and discards it.

Use this method to skip encapsulations you don't need or don't understand.

Returns:
  The amount of data discarded.
Throws:
  `MultipartStream.MalformedStreamException` - if the stream ends unexpectedly.
  `IOException` - if an i/o error occurs.

### findSeparator

protected int findSeparator()
Searches for the `boundary` in the `buffer` region delimited by `head` and `tail`.

Returns:
  The position of the boundary found, counting from the beginning of the `buffer`, or `-1` if not found.

### getHeaderEncoding

public String getHeaderEncoding()
Gets the character encoding used when reading the headers of an individual part. When not specified, or `null`, the platform default encoding is used.

Returns:
  The encoding used to read part headers.

### getPartHeaderSizeMax

public int getPartHeaderSizeMax()
Obtain the per part size limit for headers.

Returns:
  The maximum size of the headers for a single part in bytes.
Since:
  1.6.0

### newInputStream

public MultipartStream.ItemInputStream newInputStream()
Creates a new `MultipartStream.ItemInputStream`.

Returns:
  A new instance of `MultipartStream.ItemInputStream`.

### readBodyData

public int readBodyData(OutputStream output) throws MultipartStream.MalformedStreamException, IOException
Reads `body-data` from the current `encapsulation` and writes its contents into the output `Stream`.

Arbitrary large amounts of data can be processed by this method using a constant size buffer. (see `constructor`).

Parameters:
  `output` - The `Stream` to write data into. May be null, in which case this method is equivalent to `discardBodyData()`.
Returns:
  the amount of data written.
Throws:
  `MultipartStream.MalformedStreamException` - if the stream ends unexpectedly.
  `IOException` - if an i/o error occurs.

### readBoundary

public boolean readBoundary() throws FileUploadIOException, MultipartStream.MalformedStreamException
Skips a `boundary` token, and checks whether more `encapsulations` are contained in the stream.

Returns:
  `true` if there are more encapsulations in this stream; `false` otherwise.
Throws:
  `FileUploadIOException` - if the bytes read from the stream exceeded the size limits
  `MultipartStream.MalformedStreamException` - if the stream ends unexpectedly or fails to follow required syntax.

### readByte

public byte readByte() throws IOException
Reads a byte from the `buffer`, and refills it as necessary.

Returns:
  The next byte from the input stream.
Throws:
  `IOException` - if there is no more data available.

### readHeaders

public String readHeaders() throws FileUploadIOException, MultipartStream.MalformedStreamException
Reads the `header-part` of the current `encapsulation`.

Headers are returned verbatim to the input stream, including the trailing `CRLF` marker. Parsing is left to the application.

Returns:
  The `header-part` of the current encapsulation.
Throws:
  `FileUploadIOException` - if the bytes read from the stream exceeded the size limits.
  `MultipartStream.MalformedStreamException` - if the stream ends unexpectedly.

### setBoundary

public void setBoundary(byte[] boundary) throws MultipartStream.IllegalBoundaryException
Changes the boundary token used for partitioning the stream.

This method allows single pass processing of nested multipart streams.

The boundary token of the nested stream is `required` to be of the same length as the boundary token in parent stream.

Restoring the parent stream boundary token after processing of a nested stream is left to the application.

Parameters:
  `boundary` - The boundary to be used for parsing of the nested stream.
Throws:
  `MultipartStream.IllegalBoundaryException` - if the `boundary` has a different length than the one being currently parsed.

### setHeaderEncoding

public void setHeaderEncoding(String encoding)
Specifies the character encoding to be used when reading the headers of individual parts. When not specified, or `null`, the platform default encoding is used.

Parameters:
  `encoding` - The encoding used to read part headers.

### setPartHeaderSizeMax

public void setPartHeaderSizeMax(int partHeaderSizeMax)
Sets the per part size limit for headers.

Parameters:
  `partHeaderSizeMax` - The maximum size of the headers in bytes.
Since:
  1.6.0

### skipPreamble

public boolean skipPreamble() throws IOException
Finds the beginning of the first `encapsulation`.

Returns:
  `true` if an `encapsulation` was found in the stream.
Throws:
  `IOException` - if an i/o error occurs.